#include <sys/queue.h>

#include "spho/ctx.h"
#include "spho/bind.h"

struct spho_bind *
spho_bind_create(struct spho_ctx *ctx, struct spho_bind_scope *binder,
    struct spho_bind *parent)
{
	struct spho_bind *bind;

	SPHO_PRECOND(ctx != NULL);
	SPHO_PRECOND(binder != NULL);

	if ((bind = malloc(sizeof(*bind))) == NULL) {
		SPHO_ERR(binder->sc->ctx, SPHO_ERR_SYS);
		return (NULL);
	}

	bind->ctx = ctx;
	bind->binder = binder;
	bind->parent = parent;

	return (bind);
}

int
spho_bind_lkp(int, struct spho_bind *bind, struct spho_nom *nom,
    union spho_bound **out)
{
	// TODO
	return (-1);
}

void
spho_bind_destroy(struct spho_bind *bind)
{
	free(bind);
}


struct spho_bind_scope *
spho_bind_scope_create(struct spho_scope *sc)
{
	size_t sz;
	struct spho_binding *bds;
	struct spho_bind_scope *ret;

	SPHO_PRECOND(sc != NULL);

	if ((ret = malloc(sizeof(*ret))) == NULL) {
		SPHO_ERR(sc->ctx, SPHO_ERR_SYS);
		return (NULL);
	}

	if ((bds = calloc(sz, sizeof(*bds))) == NULL) {
		SPHO_ERR(sc->ctx, SPHO_ERR_SYS);
		goto err;
	}

	ret->sc = sc;
	ret->cap_bds = sz;
	ret->n_bds = 0;
	ret->bds = bds;

err:
	free(ret);

	return (NULL);
}

int
spho_binder_add_tp(struct spho_bind_scope *bdr, struct spho_nom *nom,
    struct spho_tp *tp)
{
	
}
